class ST_Badge_Supermagnet extends Hat_Ability_Automatic;

defaultproperties
{
    Begin Object Name=Mesh2
		Materials(0)=MaterialInstanceConstant'ST_Dualmagnet.Materials.ST_Dualmagnet_Mat'
    End Object
	
	HUDIcon = Texture2D'ST_Dualmagnet.Textures.ST_icondualmagnet'
	CosmeticItemName = "STsupermagnettitle"
	Description(0) = "STsupermagnetdesc"
	
}

function GivenTo( Pawn thisPawn, optional bool bDoNotActivate )
{
	Super.GivenTo(thisPawn, bDoNotActivate);
	SetTimer(0.2, true, NameOf(CheckSuckIn));
}

function CheckSuckIn()
{
    local Hat_Collectible_Bit_Base b;
    local float radius;

    radius = HasMagnetBadge() ? 500 : 200;
    foreach NearbyDynamicActors(class'Hat_Collectible_Bit_Base', b, 1000)
    {
        if (!b.Enabled) continue;
        if (b.PickupActor != None) continue;
        if (b.AttractActor != None) continue;
        if (!b.CanBeMagnetized) continue;
        if (VSize(b.Location - Instigator.Location) > radius) continue;
        b.SetAttractActor(Instigator);
    }
}

function bool HasMagnetBadge()
{
    local Hat_Ability badge;

    foreach Hat_InventoryManager(Hat_Player(Instigator).InvManager).Badges(badge)
        if (badge.IsA('Hat_Badge_SuckInOrbs'))
            return true;

    return false;
}